/*
    GTKmathplot - a simple GTK+ based program
    to plot mathematical functions.
    Copyright (C) 2012, 2013  Ivano Primi  <ivprimi@libero.it>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include<stdio.h>
#include<stdlib.h>
#include<gtk/gtk.h>
#include"cairo_driver.h"
#include"gui.h"
#include"controls.h"
#include"gnuplot.h"

int main (int argc, char* argv[])
{
  if ( (atexit (reset_internal_structs)) )
    {
      fprintf(stderr, "%s: Cannot set exit function\n", argv[0]);
      return 1;
    }
  gtk_init(&argc, &argv);
  init_cairo_driver();
  init_internal_structs();
  create_gui();
  set_gui_properties();
  load_help_file ();
  bind_callbacks();
  refresh_lists_available_ids(GRAPHIC_2D);
  refresh_lists_available_ids(GRAPHIC_3D);
  /* reinit_captions(GRAPHIC_2D); */
  /* reinit_captions(GRAPHIC_3D); */
  /* mgr_filename(""); */
  set_legend();
  show_gui();
  gtk_main();
  return 0;
}
