/*
   This file is part of the XXCalc Library - version 3.2
   Copyright (C)  2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010,
   2011, 2012, 2013    Ivano Primi ( ivprimi@libero.it )    

   The XXCalc Library is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   The XXCalc library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _HEAPSORT_H
#define _HEAPSORT_H

#include"varlist.h"
#include"calc.h"

#ifdef __cplusplus
extern "C" {
#endif

/* 'n' is always the number of the elements of 'A' */

int xx_vheapsort (xx_vartype ** A, long n); /* 'A' should be an array */
int xx_cheapsort (xx_couple * A, long n);   /* 'A' should be an array */

/* 'A' should be an array of dinamycally allocated strings */
int xx_sheapsort (const char** A, long n);  

#ifdef __cplusplus
}
#endif
#endif /* _HEAPSORT_H_ */
